%define          mainver   2.10
%undefine          betatag
%define          dwfdate   20071228


%define          fedorarel  2


%define          rel        %{?betatag:0.}%{fedorarel}%{?betatag:.%betatag}


Summary:         Calculate tide all over the world
Name:            xtide
Version:         %{mainver}
Release:         %{rel}%{?dist}

URL:             http://www.flaterco.com/xtide/
Source0:         ftp://ftp.flaterco.com/xtide/%{name}-%{version}%{?betatag:-%betatag}.tar.bz2

Source14:        xtide-get_harmonics-data.sh
Source20:        %{name}.desktop
Source30:        xtide-README.fedora

# Source41 is created by Harminics-dwf-create-regal-OK.sh in
# Source40
#
# (Updated: 2007-Nov-23) 
# Upstream now splitted free and non-free harmonics data
#                     
#Source40:        Harminics-USpart-recreate-sh.tar.bz2
#Source41:        harmonics-dwf-%{dwfdate}-dump-US.tar.bz2
Source42:        ftp://ftp.flaterco.com/xtide/harmonics-dwf-%{dwfdate}-free.tcd.bz2

License:         GPLv3+
Group:           Applications/Engineering
BuildRoot:       %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:   libXaw-devel
BuildRequires:   libXext-devel
BuildRequires:   libpng-devel
BuildRequires:   zlib-devel
BuildRequires:   desktop-file-utils
BuildRequires:   libdstr-devel
BuildRequires:   libtcd-devel

Requires:        wvs-data
Requires:        xorg-x11-fonts-base
Requires:        xtide-common

Requires(pre):      shadow-utils
Requires(preun):    /sbin/service
Requires(preun):    /sbin/chkconfig
Requires(postun):   /sbin/service
Requires(post):     /sbin/chkconfig

%package         common
Summary:         Xtide common files
Group:           Applications/Engineering
License:         Public Domain
Requires:        bzip2
Requires:        wget

%description
XTide is a package that provides tide and current
predictions in a wide variety of formats.  Graphs, text listings, and
calendars can be generated, or a tide clock can be provided on your
desktop.

XTide can work with X-windows, plain text terminals, or the web. This
is accomplished with three separate programs: the interactive
interface (xtide), the non-interactive or command line interface
(tide), and the web interface.

The algorithm that XTide uses to predict tides is the one used by the
National Ocean Service in the U.S.  It is significantly more accurate
than the simple tide clocks that can be bought in novelty stores.
However, it takes more to predict tides accurately than just a spiffy
algorithm -- you also need some special data for each and every
location for which you want to predict tides.  XTide reads this data
from harmonics files.  See http://www.flaterco.com/xtide/files.html
for details on where to get these 

NOTE:
Please also see README.fedora in xtide-common package for Fedora 
specific issue.


%description common
This package contains common files needed by xtide, xttpd and
tideEditor.
Please read README.fedora for Fedora specific issue.

%prep
%setup -q -n %{name}-%{version}%{?betatag:-%betatag}

# Dstr -> Dstr.h
set +x
echo
echo "Changing Dstr -> Dstr"
find . -type f | while read f ; do
	if grep -q 'include.*<Dstr>' $f ; then
		sed -i.name -e 's|\(include.*\)<Dstr>|\1<Dstr.h>|' $f
		echo -n -e "\t$f\tModified\n"
	fi
done
echo
set -x

%{__mkdir} TMPDIR
pushd TMPDIR
%{__cp} -p %{SOURCE42} .
%{__bzip2} -d *.bz2
popd

%build
%configure \
   --with-xttpd-user=xttpd \
   --with-xttpd-group=xttpd

%{__make} %{?_smp_mflags}

echo "%{_datadir}/xtide-harmonics/" > %{name}.conf
echo "%{_datadir}/wvs-data/" >> %{name}.conf

# create US part tcd data
pushd TMPDIR
%if 0
build_tide_db harmonics-dwf-%{dwfdate}-Fedora.tcd \
   *txt *xml
%endif
popd

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir_p} $RPM_BUILD_ROOT
 
# 1. install xtide
%{__make} \
   DESTDIR=$RPM_BUILD_ROOT \
   INSTALL="%{__install} -p" \
   install

%{__mkdir_p} $RPM_BUILD_ROOT%{_sbindir}
%{__mkdir_p} $RPM_BUILD_ROOT%{_libexecdir}

# xttpd treatment
# xttpd is wrapped
%{__sed} -e 's|20071122|%{dwfdate}|' %{SOURCE14} \
   > xtide-get_harmonics-data.sh
%{__install} -c -p -m 755 xtide-get_harmonics-data.sh \
   $RPM_BUILD_ROOT%{_sbindir}

%{__mv} $RPM_BUILD_ROOT%{_sbindir}/xttpd $RPM_BUILD_ROOT%{_libexecdir}
%{__install} -c -p -m 755 scripts/Fedora/xttpd-wrapper.sh \
   $RPM_BUILD_ROOT%{_sbindir}/xttpd

# ensure xttpd binary installation directory (original
# wrapper script is hardcorded)
%{__sed} -i -e 's|/usr/libexec|%{_libexecdir}|' \
   $RPM_BUILD_ROOT%{_sbindir}/xttpd


# 1A Install harmonics file
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}-harmonics

# 1B Add configuration file
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}
%{__install} -c -p -m 644 %{name}.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/

# 1C Add desktop entry (xtide)
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install \
   --vendor fedora \
   --dir $RPM_BUILD_ROOT%{_datadir}/applications \
   %{SOURCE20}

# 1D Install icon
for f in iconsrc/icon_*_orig.png ; do
   %{__install} -c -p -m 644 $f $RPM_BUILD_ROOT%{_datadir}/%{name}/
done
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/
%{__ln_s} -f ../../../../%{name}/icon_16x16_orig.png \
   $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{__ln_s} -f ../../../../%{name}/icon_48x48_orig.png \
   $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png

# 1E install xttpd conf file
%{__mkdir_p} $RPM_BUILD_ROOT%{_initrddir}
%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/xtide

%{__install} -c -p -m 755 scripts/Fedora/rc.xttpd \
   $RPM_BUILD_ROOT%{_initrddir}/xttpd
%{__install} -c -p -m 644 scripts/Fedora/xttpd.conf \
   $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/xttpd

# 1F and others
%{__install} -c -p -m 644 %{SOURCE30} README.fedora

# 1G tcd data
%{__install} -c -p -m 644 TMPDIR/*tcd \
   $RPM_BUILD_ROOT%{_datadir}/xtide-harmonics/

# 2 Documentation
for f in AUTHORS ChangeLog NEWS README ; do
   iconv -f ISO-8859-1 -t UTF-8 $f > $f.tmp && \
      ( touch -r $f $f.tmp ; mv -f $f.tmp $f ) || rm -f $f.tmp
done

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post
touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :

/sbin/chkconfig --add xttpd

%postun
touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :

if [ $1 -ge 1 ] ; then
   /sbin/service xttpd condrestart &>/dev/null || :
fi

%pre
getent group xttpd &>/dev/null || \
   %{_sbindir}/groupadd -r xttpd
getent passwd xttpd &> /dev/null || \
   %{_sbindir}/useradd \
   -c "XTide web server" \
   -g xttpd \
   -d %{_sysconfdir}/%{name} \
   -r \
   -s /sbin/nologin \
   xttpd 2>/dev/null
exit 0

%preun
if [ $1 = 0 ] ; then
   /sbin/service xttpd stop &>/dev/null
   /sbin/chkconfig --del xttpd
fi

%files common
%doc README.fedora
%config(noreplace) %{_sysconfdir}/%{name}.conf

%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}-harmonics
%dir %{_sysconfdir}/%{name}

%{_sbindir}/xtide-get*.sh

# Now include tcd data
%{_datadir}/%{name}-harmonics/*.tcd

%files
%defattr(-,root,root,-)

%doc AUTHORS COPYING README README-QUICK
# xtide
%{_mandir}/man1/*tide.1*

%{_datadir}/applications/fedora-%{name}.desktop
%{_datadir}/icons/hicolor/*/apps/%{name}.png
%{_datadir}/%{name}/icon_*_orig.png

%{_bindir}/*tide

# xttpd
%config(noreplace) %{_sysconfdir}/sysconfig/xttpd
%{_initrddir}/xttpd

%{_sbindir}/xttpd
%{_libexecdir}/xttpd
%{_datadir}/man/man8/xttpd.8*

%changelog
* Thu Feb  7 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.10-2
- Use system-wide libdstr (review request 431692 passed)

* Wed Feb  6 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.10-1
- 2.10

* Sat Jan 19 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.10-0.1.RC1
- Try 2.10 RC1

* Sun Dec 30 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.5-2
- Update harmonics data to 20071228

* Wed Dec 12 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.5-1
- 2.9.5

* Fri Nov 23 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.4-3
- Update harmonics data to 20071122.

* Wed Sep  5 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.4-1
- 2.9.4
  (Relicensed: GPLv2+ -> GPLv3+)
- Update user creation script

* Wed Aug 22 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.3-3.dist.2
- Mass rebuild (buildID or binutils issue)

* Fri Aug  3 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.3-3.dist.1
- License update

* Mon Jun 11 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.3-3
- Require needed fonts (bug reported from upstream)

* Thu May 31 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.3-2
- Ship US part tcd data, which are under public domain.

* Wed Apr 18 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.3-1
- 2.9.3

* Mon Apr  3 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.2-1
- 2.9.2

* Thu Mar 15 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9.1-1
- 2.9.1

* Wed Feb 28 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-1
- 2.9

* Sun Feb 18 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.3.RC3
- 2.9 RC3

* Wed Feb 14 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.3.RC2
- 2.9 RC2

* Fri Feb  2 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.3.RC1
- 2.9 RC1

* Mon Jan 22 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20070120
- 2.9 dev 20070120

* Wed Jan 17 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20070115
- 2.9 dev 20070115

* Tue Jan  9 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20070108
- 2.9 dev 20070108

* Fri Jan  6 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20070103
- 2.9 dev 20070103

* Fri Dec 22 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20061222
- 2.9 dev 20061222

* Fri Dec 22 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20061221
- 2.9 dev 20061221

* Tue Dec 12 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20061210
- 2.9 dev 20061210

* Mon Dec  4 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20061203
- 2.9 dev 20061203
- Update desktop files
- Use scripts in source tarball
- Drop harmonics data description

* Wed Nov 29 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp>
- Add more BuildRequires only for FC-5.

* Sun Nov 26 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.date20061122
- Ensure the hardcorded directories in some scripts can be 
  appropriately changed.
- Fix some typo in README.fedora

* Thu Nov 23 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.1.date20061122
- 2.9 dev 20061122 release

* Mon Nov 20 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.1.dev1
- Version down temporarily
- re-split libtcd, tcd-utils (see bug 211626)
- again include xttpd

* Sun Oct 29 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.14.dev20061027
- xtide-2.9dev20061029, tcd-utils-1.3.11(2005-08-11),
  update patches.
- Remove -DCOMPAT114 as required by newer tcd-utils
- Bump somajor of tcd-utils for API change.

* Fri Oct 27 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.13.dev20061015
- Fix some change in xtide-2.9dev-change-uidgid.patch

* Fri Oct 27 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.12.dev20061015
- More restrictive uid/gid mode for xttpd
- Another fix for xttpd.init

* Thu Oct 26 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.11.dev20061015
- Other fixes for xttpd.init, xttpd.conf
- Create "xttpd" user and use xttpd user for daemon.

* Wed Oct 25 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.10.dev20061015
- xtide doesn't need wrapperd, however, xttpd does.
- Fix xttpd init script

* Wed Oct 25 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.9.dev20061015
- Adjustment for WVS data directory change.

* Wed Oct 25 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.8.dev20061015
- Split WVS data.
- desktop-file-utils 0.11 change: X-Fedora, Application is no longer
  accepted (will be fixed in rawhide).

* Wed Oct 25 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.7.dev20061015
- Drop harmonics data for now.
- Define WVS_DIR, then rewrite tideEditor-wrapper.sh and wrap xtide
- Add fedora-specific document
- Include WVS data

* Sun Oct 22 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.6.dev20061015
- Install 48x48 icon as well.

* Sun Oct 22 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.5.dev20061015
- Use icon in xtide source
- Fix Group entry
- Re-source profile shell script for easier rebuilding

* Sun Oct 22 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.4.dev20061015
- Introduce common files package.
- CFLAGS treatment change.
- Treak configuration files and their locations.

* Sat Oct 21 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.3.dev20061015
- Various changes about compilation optflags.
- Change libtcd soname numbering
- Sprit xttpd, include scripts
- tideEditor wrapper script included and desktop files added.
- use "/sbin/ldconfig -n"
- Lots of help from Michael Schwendt and Patrice Dumas, thanks!!

* Sat Oct 21 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.2.dev20061015
- Re-unify libtcd and xtide, and include tcd-utils, 
  build all at once.

* Fri Oct 20 2006 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.9-0.1.dev20061015
- Resubmit to Fedora Extras (bug #211626)
- Split libtcd to another package, require tcd-utils to
  rebuild tcd data.

* Sun May 22 2005 Jeremy Katz <katzj@redhat.com> - 2.8-4
- rebuild on all arches

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Fri Dec 17 2004 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.8-2
- Made a small hack that should make it compile on x86_64 systems.

* Wed Dec 15 2004 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.8-1
- Updated to version 2.8
- Cleaned up spec file because much of the tricks to get it to work
  are no longer necessary.

* Mon Dec  8 2003 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.6.4-0.fdr.4
- Removed 644 permissions.

* Tue Dec  2 2003 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.6.4-0.fdr.3
- Fixed problem with debuginfo rpm and lex.xml.c.
- Changed attributes to 644/755 to agree with Fedora specification.

* Mon Nov 17 2003 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.6.4-0.fdr.1
- Updated to 2.6.4 version of xtide

* Mon Oct 20 2003 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.6.3-0.fdr.2
- Made changes to spec and patch as per Michael Schwendt's suggestions

* Fri Oct 17 2003 David M. Kaplan <dmk@erizo.ucdavis.edu> 0:2.6.3-0.fdr.1
- Modified spec file to meet requirements for fedora

* Tue Oct 14 2003 David M. Kaplan <dmk@erizo.ucdavis.edu> 2.6.3-0.fdr.0
- Modify for Fedora submission

* Tue Oct 14 2003 David M. Kaplan <dmkaplan@ucdavis.edu> 2.6.3-0
- Update to XTide 2.6.3

* Fri Sep 05 2003 David M. Kaplan <dmkaplan@ucdavis.edu>
- Updated to XTide 2.6.2

* Thu Feb 17 2003 David M. Kaplan <dmkaplan@ucdavis.edu>
- Updated to XTide 2.6 FINAL (2003-02-12)

* Thu Feb 17 2003 David M. Kaplan <dmkaplan@ucdavis.edu>
- Updated to XTide 2.6 DEVELOPMENT (2003-02-12)

* Thu Jan 23 2003 David M. Kaplan <dmkaplan@ucdavis.edu>
- Updated to XTide 2.6 DEVELOPMENT (2003-01-17)

* Sat Dec 28 2002 David M. Kaplan <dmkaplan@ucdavis.edu>
- First RPM build.

